/* GCC */

#include <stdio.h>
#include <vector>
#include <queue>

using namespace std;

int n; // ʳ  
vector<queue<int> > all; // all[v - 1]     v
queue<pair<int, int> > edges; //   ,     

//        v    , 
//     ,     ,   .
inline void pop(int v)
{
    all[v - 1].pop();
    if (!all[v - 1].empty())
    {
        int adjacent = all[v - 1].front();
        if (!all[adjacent - 1].empty() && all[adjacent - 1].front() == v)
            edges.push(make_pair(min(v, adjacent), max(v, adjacent)));
    }
}

int main()
{
    freopen("graph.in", "r", stdin);
    freopen("graph.out", "w", stdout);

    scanf("%d\n", &n);

    //         edges:
    for (int v = 1; v <= n; v++)
    {
        queue<int> adj; //  ,   
        int num = 0; //   
        while (true)
        {
            char c;
            scanf("%c", &c); //      ,  
            if (c >= '0' && c <= '9') //      
                num = num * 10 + (c - '0');
            else //         
            {
                adj.push(num);
                num = 0;
            }
            if (c == '\n') //      ,   
                break;
        }
        all.push_back(adj);
        //       ,     
        //      ,     :
        if (adj.front() < v && all[adj.front() - 1].front() == v)
            edges.push(make_pair(adj.front(), v));
    }

    while (!edges.empty())
    {
        pair<int, int> edge = edges.front();
        edges.pop();
        printf("%d %d\n", edge.first, edge.second);
        pop(edge.first);
        pop(edge.second);
    }

    return 0;
}
