/* GCC */

#include <stdio.h>
#include <algorithm>

using namespace std;

//      divisor,     n.
//    n   .
inline int getPowerAndDivide(int &n, int divisor)
{
    int power = 0;
    while (n % divisor == 0)
    {
        power++;
        n /= divisor;
    }
    return power;
}

// ,       ,  ,   .
inline bool check(int a, int b, int c)
{
    return a * b % c == 0 && a * c % b == 0 && b * c % a == 0;
}

int main()
{
    freopen("numbers.in", "r", stdin);
    freopen("numbers.out", "w", stdout);

    int a, b;
    scanf("%d %d", &a, &b);

    int ans = 1;

    int m = max(a, b), curA = a, curB = b;
    for (int divisor = 2; divisor <= m; divisor++)
    {
        int powerA = getPowerAndDivide(curA, divisor);
        int powerB = getPowerAndDivide(curB, divisor);
        //      powerA  powerB  ,
        //    (divisor)      .
        ans *= (powerA + powerB) - abs(powerA - powerB) + 1;
    }

    //   ,       :
    if (check(a, a, b))
        ans--;
    if (check(a, b, b))
        ans--;

    printf("%d\n", ans);

    return 0;
}
